import java.util.Scanner;

public class Lipud4 {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        // alustame esimeselt realt, kust kutsutakse
        // rekursiivselt vlja jrgmiste ridade proovimisi
        int res = tryrow(0, (n + 1) / 2, n);
        System.out.println(res);
    }

    static int MAXN = 16;

    // peame meeles, millistel ridadel, veergudel ja diagonaalidel lipud on
    static char[] row = new char[MAXN];
    static char[] col = new char[MAXN]; // (i, j) -> j
    static char[] updiag = new char[2 * MAXN]; // (i, j) -> i + j
    static char[] downdiag = new char[2 * MAXN]; // (i, j) -> i - j + N

    static int tryrow(int y, int lim, int n) { // lim = mitut esimese ruutu proovida
        int res = 0;
        if (y == n) {
            res++;
            if (row[0] < n / 2) res++; // esimese rea esimese poole loeme topelt
            return res;
        }
        for (int x = 0; x < lim; x++) { // proovime kiki veerge
            // kontrollime, kas veerg+diagonaalid on vabad
            if (col[x] == 0 && updiag[y + x] == 0 && downdiag[y - x + MAXN] == 0) {
                row[y] = (char)x;
                col[x] = 1; // mrgime veeru kasutatuks
                updiag[y + x] = 1;
                downdiag[y - x + MAXN] = 1;
                res += tryrow(y + 1, n, n); // liidame kik jrgmiste ridade vimalused
                col[x] = 0;
                updiag[y + x] = 0;
                downdiag[y - x + MAXN] = 0;
            }
        }
        return res;
    }
}
