import java.util.Scanner;

public class JPerm {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        String s = scanner.nextLine();
        String p = jargmine_perm(s, s.length());

        while (!p.equals(s)) {
            System.out.println(p);
            p = jargmine_perm(p, p.length());
        }
        System.out.println(p);
    }

    static String jargmine_perm(String s, int pikkus)
    {
        char[] vastus = new char[pikkus];
        for (int i = 0; i < pikkus; i++) {
            vastus[i] = s.charAt(i);
        }
        for (int i = pikkus - 2; i >= 0; i--) {
            //vrdleme, millise indeksini on tagumine osa kahanevas jrjekorras
            if (vastus[i] < vastus[i + 1]) {
                //lheme tagasi theni, mis on <= kui vaadeldav, asendame 1 enne seda
                int j = pikkus;
                while (!(vastus[i] < vastus[--j]));
                //vahetame i ja j
                char tmp = vastus[j];
                vastus[j] = vastus[i];
                vastus[i] = tmp;
                //keerame jada saba prast i-d mber
                reverse(vastus, i + 1, pikkus - 1);
                String str = new String(vastus);
                return str;
            }
        }
        //Kui kik on algusest kahanevas jrjekorras, keerame kogu jada mber
        reverse(vastus, 0, pikkus - 1);
        String str = new String(vastus);
        return str;
    }

    static void reverse(char[] array, int left, int right){
        while(left<right){
            char temp = array[left];
            array[left]=array[right];
            array[right]=temp;
            left++;
            right--;
        }
    }
}
